package renderer

import (
	"net/http"

	diagsstorage "git.coopgo.io/coopgo-platform/diags/storage"
)

const diagsMenu = "diags"

func (renderer *Renderer) DiagsHome(w http.ResponseWriter, r *http.Request, diags []diagsstorage.Diag) {
	files := renderer.ThemeConfig.GetStringSlice("views.diags.list.files")
	state := NewState(r, renderer.ThemeConfig, diagsMenu)
	state.ViewState = map[string]any{
		"diags": diags,
	}

	renderer.Render("diags home", w, r, files, state)
}

func (renderer *Renderer) DiagsHistory(w http.ResponseWriter, r *http.Request, diags []diagsstorage.Diag) {
	files := renderer.ThemeConfig.GetStringSlice("views.diags.history.files")
	state := NewState(r, renderer.ThemeConfig, diagsMenu)
	state.ViewState = map[string]any{
		"diags": diags,
	}

	renderer.Render("diags history", w, r, files, state)
}

func (renderer *Renderer) BeneficiariesCreateDiag(w http.ResponseWriter, r *http.Request, beneficiary string) {
	state := NewState(r, renderer.ThemeConfig, diagsMenu)
	files := renderer.ThemeConfig.GetStringSlice("views.beneficiaries.create_diag.files")
	state.ViewState = map[string]any{
		"beneficiary": beneficiary,
	}
	renderer.Render("diag create for beneficiary", w, r, files, state)
}

func (renderer *Renderer) DiagsDisplayDiag(w http.ResponseWriter, r *http.Request, diag any) {
	files := renderer.ThemeConfig.GetStringSlice("views.diags.display_diag.files")
	state := NewState(r, renderer.ThemeConfig, diagsMenu)

	state.ViewState = map[string]any{
		"diag":         	 diag,
	}

	renderer.Render("diags create diag", w, r, files, state)
}

func (renderer *Renderer) DiagsHistoryDiag(w http.ResponseWriter, r *http.Request, diag any) {
	files := renderer.ThemeConfig.GetStringSlice("views.diags.history_diag.files")
	state := NewState(r, renderer.ThemeConfig, diagsMenu)
	state.ViewState = map[string]any{
		"diag":         diag,
	}

	renderer.Render("diags history diag", w, r, files, state)
}

func (renderer *Renderer) DiagsUpdateDiag(w http.ResponseWriter, r *http.Request, diag any) {
	files := renderer.ThemeConfig.GetStringSlice("views.diags.update.files")
	state := NewState(r, renderer.ThemeConfig, diagsMenu)

	state.ViewState = map[string]any{
		"diag": diag,
	}

	renderer.Render("diag_update", w, r, files, state)
}

func (renderer *Renderer) DiagsDeleteDiag(w http.ResponseWriter, r *http.Request, diag any) {
	files := renderer.ThemeConfig.GetStringSlice("views.diags.delete.files")
	state := NewState(r, renderer.ThemeConfig, diagsMenu)

	state.ViewState = map[string]any{
		"diag": diag,
	}

	renderer.Render("diag_deleteDiag", w, r, files, state)
}